package com.logicbig.example;

public class RegexPerformanceTest {

    public static void main(String[] args) {
        String str = getString();
        for (int i = 0; i < 3; i++) {
            TimerUtil.runTask("regex replace",
                    () -> {
                        String result = str.replaceAll("\\n+", " ");
                        // System.out.println(result);
                    });
            TimerUtil.runTask("manual replace",
                    () -> {
                        String result = manualReplace(str, "\n", " ");
                        //System.out.println(result);
                    });
            System.out.println("-----");
        }
    }

    private static String getString() {
        String rv = "";
        for (int i = 0; i < 10000; i++) {
            rv += "test string \n ends.. ";
        }
        return "'" + rv + "'";
    }

    private static String manualReplace(String input, String toReplace, String replaceWith) {
        int i = input.indexOf(toReplace);
        while (i != -1) {
            input = input.substring(0, i) + replaceWith + input.substring(i + toReplace.length());
            i = input.indexOf(toReplace, i + replaceWith.length());
        }
        return input;
    }
}